<?php

namespace Ulmus\Api\Common;

use Psr\Http\Message\MessageInterface;
use Ulmus\Api\Stream\JsonStream;

trait JsonMessageTrait
{
    public function getParsedBody(): mixed
    {
        return JsonStream::fromJsonEncoded( $this->getBody()->getContents() )->decode() ;
    }

    public function withParsedBody(mixed $data) : MessageInterface
    {
        return (clone $this)->setBody(
            JsonStream::fromContent($data)
        );
    }
}